/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiDomainEventTable.h 5405 2005-11-09 22:14:23Z ddearauj $
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#ifndef SAHPIDOMAINEVENTTABLE_H
#define SAHPIDOMAINEVENTTABLE_H

#ifdef __cplusplus
extern "C" {
#endif

    
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>

#include <hpiSubagent.h>
        /** Index saHpiDomainId is external */
        /** Index saHpiDomainEventEntryId is internal */
        /** Index saHpiEventSeverity is external */

typedef struct saHpiDomainEventTable_context_s {
    netsnmp_index index; /** THIS MUST BE FIRST!!! */

    /*************************************************************
     * You can store data internally in this structure.
     *
     * TODO: You will probably have to fix a few types here...
     */
    /** TODO: add storage for external index(s)! */
        /** SaHpiEntryId = ASN_UNSIGNED */
            unsigned long saHpiDomainEventEntryId;

        /** SaHpiTime = ASN_OCTET_STR */
            unsigned char saHpiDomainEventTimestamp[SAF_UNSIGNED_64_LEN];
            long saHpiDomainEventTimestamp_len;
	    
        /** INTEGER = ASN_INTEGER */
            long saHpiDomainEventType;


    /*
     * OR
     *
     * Keep a pointer to your data
     */
    void * data;

    /*
     *add anything else you want here
     */

} saHpiDomainEventTable_context;

/*************************************************************
 * function declarations
 */
void init_saHpiDomainEventTable(void);
void initialize_table_saHpiDomainEventTable(void);
const saHpiDomainEventTable_context * saHpiDomainEventTable_get_by_idx(netsnmp_index *);
const saHpiDomainEventTable_context * saHpiDomainEventTable_get_by_idx_rs(netsnmp_index *,
                                        int row_status);
int saHpiDomainEventTable_get_value(netsnmp_request_info *, netsnmp_index *, netsnmp_table_request_info *);

/*************************************************************
 * function declarations: OpenHpi
 */
SaErrorT populate_saHpiDomainEventTable(SaHpiSessionIdT sessionid,
                                        SaHpiEventT *event,
                                        oid * event_oid, 
                                        size_t *event_oid_len);
SaErrorT async_domain_event_add(SaHpiSessionIdT sessionid, 
                                SaHpiEventT *event,
				SaHpiRdrT *rdr,
                                SaHpiRptEntryT *rpt_entry,
                                oid * this_child_oid, 
                                size_t *this_child_oid_len);


/*************************************************************
 * oid declarations
 */
extern oid saHpiDomainEventTable_oid[];
extern size_t saHpiDomainEventTable_oid_len;

#define saHpiDomainEventTable_TABLE_OID 1,3,6,1,4,1,18568,2,1,1,3,1,9
    
/*************************************************************
 * column number definitions for table saHpiDomainEventTable
 */
#define DOMAIN_EVENT_INDEX_NR 3 
#define COLUMN_SAHPIDOMAINEVENTENTRYID 1
#define COLUMN_SAHPIDOMAINEVENTTIMESTAMP 2
#define COLUMN_SAHPIDOMAINEVENTTYPE 3
#define saHpiDomainEventTable_COL_MIN 1
#define saHpiDomainEventTable_COL_MAX 3

/* comment out the following line if you don't handle SET-REQUEST for saHpiDomainEventTable */
#define saHpiDomainEventTable_SET_HANDLING

/* comment out the following line if you can't create new rows */
#define saHpiDomainEventTable_ROW_CREATION

/* comment out the following line if you don't want the secondary index */
#define saHpiDomainEventTable_IDX2

/* uncommend the following line if you allow modifications to an
 * active row */
/** define saHpiDomainEventTable_CAN_MODIFY_ACTIVE_ROW */

#ifdef saHpiDomainEventTable_SET_HANDLING

int saHpiDomainEventTable_extract_index( saHpiDomainEventTable_context * ctx, netsnmp_index * hdr );

void saHpiDomainEventTable_set_reserve1( netsnmp_request_group * );
void saHpiDomainEventTable_set_reserve2( netsnmp_request_group * );
void saHpiDomainEventTable_set_action( netsnmp_request_group * );
void saHpiDomainEventTable_set_commit( netsnmp_request_group * );
void saHpiDomainEventTable_set_free( netsnmp_request_group * );
void saHpiDomainEventTable_set_undo( netsnmp_request_group * );

saHpiDomainEventTable_context * saHpiDomainEventTable_duplicate_row( saHpiDomainEventTable_context* );
netsnmp_index * saHpiDomainEventTable_delete_row( saHpiDomainEventTable_context* );

int saHpiDomainEventTable_can_activate(saHpiDomainEventTable_context *undo_ctx,
                      saHpiDomainEventTable_context *row_ctx,
                      netsnmp_request_group * rg);
int saHpiDomainEventTable_can_deactivate(saHpiDomainEventTable_context *undo_ctx,
                        saHpiDomainEventTable_context *row_ctx,
                        netsnmp_request_group * rg);
int saHpiDomainEventTable_can_delete(saHpiDomainEventTable_context *undo_ctx,
                    saHpiDomainEventTable_context *row_ctx,
                    netsnmp_request_group * rg);
    
    
#ifdef saHpiDomainEventTable_ROW_CREATION
saHpiDomainEventTable_context * saHpiDomainEventTable_create_row( netsnmp_index* );
#endif
#endif

#ifdef saHpiDomainEventTable_IDX2
saHpiDomainEventTable_context * saHpiDomainEventTable_get( const char *name, int len );
#endif

#ifdef __cplusplus
};
#endif

#endif /** SAHPIDOMAINEVENTTABLE_H */
