/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiHotSwapEventTable.h 5405 2005-11-09 22:14:23Z ddearauj $
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#ifndef SAHPIHOTSWAPEVENTTABLE_H
#define SAHPIHOTSWAPEVENTTABLE_H

#ifdef __cplusplus
extern "C" {
#endif

    
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>

#include <hpiSubagent.h>
        /** Index saHpiDomainId is external */
        /** Index saHpiResourceId is external */
        /** Index saHpiEventSeverity is external */
        /** Index saHpiHotSwapEventEntryId is internal */

typedef struct saHpiHotSwapEventTable_context_s {
    netsnmp_index index; /** THIS MUST BE FIRST!!! */

    /*************************************************************
     * You can store data internally in this structure.
     *
     * TODO: You will probably have to fix a few types here...
     */
    /** TODO: add storage for external index(s)! */
        /** SaHpiEntryId = ASN_UNSIGNED */
            unsigned long saHpiHotSwapEventEntryId;

        /** SaHpiTime = ASN_OCTET_STR */
            unsigned char saHpiHotSwapEventTimestamp[SAF_UNSIGNED_64_LEN];
	    long saHpiHotSwapEventTimestamp_len;

        /** SaHpiHotSwapState = ASN_INTEGER */
            long saHpiHotSwapEventState;

        /** SaHpiHotSwapState = ASN_INTEGER */
            long saHpiHotSwapEventPreviousState;


    /*
     * OR
     *
     * Keep a pointer to your data
     */
    void * data;

    /*
     *add anything else you want here
     */

} saHpiHotSwapEventTable_context;

/*************************************************************
 * function declarations
 */
void init_saHpiHotSwapEventTable(void);
void initialize_table_saHpiHotSwapEventTable(void);
const saHpiHotSwapEventTable_context * saHpiHotSwapEventTable_get_by_idx(netsnmp_index *);
const saHpiHotSwapEventTable_context * saHpiHotSwapEventTable_get_by_idx_rs(netsnmp_index *,
                                        int row_status);
int saHpiHotSwapEventTable_get_value(netsnmp_request_info *, netsnmp_index *, netsnmp_table_request_info *);

/*************************************************************
 * function declarations: OpenHpi
 */
SaErrorT populate_saHpiHotSwapEventTable(SaHpiSessionIdT sessionid,
                                        SaHpiEventT *event,
                                        oid * event_oid, 
                                        size_t *event_oid_len);
SaErrorT async_hotswap_event_add(SaHpiSessionIdT sessionid, 
                                 SaHpiEventT *event,
                                 SaHpiRdrT *rdr,
				 SaHpiRptEntryT *rpt_entry,				 
                                 oid * this_child_oid, 
                                 size_t *this_child_oid_len);


/*************************************************************
 * oid declarations
 */
extern oid saHpiHotSwapEventTable_oid[];
extern size_t saHpiHotSwapEventTable_oid_len;

#define saHpiHotSwapEventTable_TABLE_OID 1,3,6,1,4,1,18568,2,1,1,3,1,18
    
/*************************************************************
 * column number definitions for table saHpiHotSwapEventTable
 */
 
#define HOTSWAP_EVENT_INDEX_NR 4
#define COLUMN_SAHPIHOTSWAPEVENTENTRYID 1
#define COLUMN_SAHPIHOTSWAPEVENTTIMESTAMP 2
#define COLUMN_SAHPIHOTSWAPEVENTSTATE 3
#define COLUMN_SAHPIHOTSWAPEVENTPREVIOUSSTATE 4
#define saHpiHotSwapEventTable_COL_MIN 2
#define saHpiHotSwapEventTable_COL_MAX 4

/* comment out the following line if you don't handle SET-REQUEST for saHpiHotSwapEventTable */
#define saHpiHotSwapEventTable_SET_HANDLING

/* comment out the following line if you can't create new rows */
#define saHpiHotSwapEventTable_ROW_CREATION

/* comment out the following line if you don't want the secondary index */
#define saHpiHotSwapEventTable_IDX2

/* uncommend the following line if you allow modifications to an
 * active row */
/** define saHpiHotSwapEventTable_CAN_MODIFY_ACTIVE_ROW */

#ifdef saHpiHotSwapEventTable_SET_HANDLING

int saHpiHotSwapEventTable_extract_index( saHpiHotSwapEventTable_context * ctx, netsnmp_index * hdr );

void saHpiHotSwapEventTable_set_reserve1( netsnmp_request_group * );
void saHpiHotSwapEventTable_set_reserve2( netsnmp_request_group * );
void saHpiHotSwapEventTable_set_action( netsnmp_request_group * );
void saHpiHotSwapEventTable_set_commit( netsnmp_request_group * );
void saHpiHotSwapEventTable_set_free( netsnmp_request_group * );
void saHpiHotSwapEventTable_set_undo( netsnmp_request_group * );

saHpiHotSwapEventTable_context * saHpiHotSwapEventTable_duplicate_row( saHpiHotSwapEventTable_context* );
netsnmp_index * saHpiHotSwapEventTable_delete_row( saHpiHotSwapEventTable_context* );

int saHpiHotSwapEventTable_can_activate(saHpiHotSwapEventTable_context *undo_ctx,
                      saHpiHotSwapEventTable_context *row_ctx,
                      netsnmp_request_group * rg);
int saHpiHotSwapEventTable_can_deactivate(saHpiHotSwapEventTable_context *undo_ctx,
                        saHpiHotSwapEventTable_context *row_ctx,
                        netsnmp_request_group * rg);
int saHpiHotSwapEventTable_can_delete(saHpiHotSwapEventTable_context *undo_ctx,
                    saHpiHotSwapEventTable_context *row_ctx,
                    netsnmp_request_group * rg);
    
    
#ifdef saHpiHotSwapEventTable_ROW_CREATION
saHpiHotSwapEventTable_context * saHpiHotSwapEventTable_create_row( netsnmp_index* );
#endif
#endif

#ifdef saHpiHotSwapEventTable_IDX2
saHpiHotSwapEventTable_context * saHpiHotSwapEventTable_get( const char *name, int len );
#endif

#ifdef __cplusplus
};
#endif

#endif /** SAHPIHOTSWAPEVENTTABLE_H */
