/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiSensorReadingNormalMaxTable.h 5354 2005-10-05 15:36:19Z ddearauj $
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#ifndef SAHPISENSORREADINGNORMALMAXTABLE_H
#define SAHPISENSORREADINGNORMALMAXTABLE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>

/** Index saHpiDomainId is external */
/** Index saHpiResourceId is external */
/** Index saHpiResourceIsHistorical is external */
/** Index saHpiSensorNum is external */

typedef struct saHpiSensorReadingNormalMaxTable_context_s {
	netsnmp_index index; /** THIS MUST BE FIRST!!! */

	/*************************************************************
	 * You can store data internally in this structure.
	 *
	 * TODO: You will probably have to fix a few types here...
	 */
	/** TODO: add storage for external index(s)! */
	/** TruthValue = ASN_INTEGER */
	long saHpiSensorReadingNormalMaxIsSupported;

	/** SaHpiSensorReadingType = ASN_INTEGER */
	long saHpiSensorReadingNormalMaxType;

	/** SaHpiSensorReadingValue = ASN_OCTET_STR */
	unsigned char saHpiSensorReadingNormalMaxValue[SAHPI_SENSOR_BUFFER_LENGTH];
	long saHpiSensorReadingNormalMaxValue_len;


	/*
	 * OR
	 *
	 * Keep a pointer to your data
	 */
	void * data;

	/*
	 *add anything else you want here
	 */

} saHpiSensorReadingNormalMaxTable_context;

/*
 * SaErrorT populate_sensor_max()
 */
SaErrorT populate_sensor_normal_max(SaHpiSessionIdT sessionid, 
					    SaHpiRdrT *rdr_entry,
					    SaHpiRptEntryT *rpt_entry);
SaErrorT clear_sensor_normal_max(SaHpiDomainIdT domainId, 
                              SaHpiResourceIdT resourceId);

/*************************************************************
 * function declarations
 */
void init_saHpiSensorReadingNormalMaxTable(void);
void initialize_table_saHpiSensorReadingNormalMaxTable(void);
const saHpiSensorReadingNormalMaxTable_context * saHpiSensorReadingNormalMaxTable_get_by_idx(netsnmp_index *);
const saHpiSensorReadingNormalMaxTable_context * saHpiSensorReadingNormalMaxTable_get_by_idx_rs(netsnmp_index *,
												int row_status);
int saHpiSensorReadingNormalMaxTable_get_value(netsnmp_request_info *, netsnmp_index *, netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
extern oid saHpiSensorReadingNormalMaxTable_oid[];
extern size_t saHpiSensorReadingNormalMaxTable_oid_len;

#define saHpiSensorReadingNormalMaxTable_TABLE_OID 1,3,6,1,4,1,18568,2,1,1,4,9,7

/* Number of table Indexes */
#define SENSOR_READING_NORMAL_MAX_INDEX_NR 4 
#define saHpiSenNormMaxDomainId_INDEX 0
#define saHpiSenNormMaxResourceId_INDEX 1
#define saHpiSenNormMaxResourceIsHistorical_INDEX 2
#define saHpiSensorNormMaxNum_INDEX 3


/*************************************************************
 * column number definitions for table saHpiSensorReadingNormalMaxTable
 */
#define COLUMN_SAHPISENSORREADINGNORMALMAXISSUPPORTED 1
#define COLUMN_SAHPISENSORREADINGNORMALMAXTYPE 2
#define COLUMN_SAHPISENSORREADINGNORMALMAXVALUE 3
#define saHpiSensorReadingNormalMaxTable_COL_MIN 1
#define saHpiSensorReadingNormalMaxTable_COL_MAX 3

int saHpiSensorReadingNormalMaxTable_extract_index( saHpiSensorReadingNormalMaxTable_context * ctx, netsnmp_index * hdr );

void saHpiSensorReadingNormalMaxTable_set_reserve1( netsnmp_request_group * );
void saHpiSensorReadingNormalMaxTable_set_reserve2( netsnmp_request_group * );
void saHpiSensorReadingNormalMaxTable_set_action( netsnmp_request_group * );
void saHpiSensorReadingNormalMaxTable_set_commit( netsnmp_request_group * );
void saHpiSensorReadingNormalMaxTable_set_free( netsnmp_request_group * );
void saHpiSensorReadingNormalMaxTable_set_undo( netsnmp_request_group * );

saHpiSensorReadingNormalMaxTable_context * saHpiSensorReadingNormalMaxTable_duplicate_row( saHpiSensorReadingNormalMaxTable_context* );
netsnmp_index * saHpiSensorReadingNormalMaxTable_delete_row( saHpiSensorReadingNormalMaxTable_context* );

int saHpiSensorReadingNormalMaxTable_can_activate(saHpiSensorReadingNormalMaxTable_context *undo_ctx,
						  saHpiSensorReadingNormalMaxTable_context *row_ctx,
						  netsnmp_request_group * rg);
int saHpiSensorReadingNormalMaxTable_can_deactivate(saHpiSensorReadingNormalMaxTable_context *undo_ctx,
						    saHpiSensorReadingNormalMaxTable_context *row_ctx,
						    netsnmp_request_group * rg);
int saHpiSensorReadingNormalMaxTable_can_delete(saHpiSensorReadingNormalMaxTable_context *undo_ctx,
						saHpiSensorReadingNormalMaxTable_context *row_ctx,
						netsnmp_request_group * rg);


saHpiSensorReadingNormalMaxTable_context * saHpiSensorReadingNormalMaxTable_create_row( netsnmp_index* );

saHpiSensorReadingNormalMaxTable_context * saHpiSensorReadingNormalMaxTable_get( const char *name, int len );

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORREADINGNORMALMAXTABLE_H */
