/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiSensorReadingNormalMinTable.h 5354 2005-10-05 15:36:19Z ddearauj $
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#ifndef SAHPISENSORREADINGNORMALMINTABLE_H
#define SAHPISENSORREADINGNORMALMINTABLE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>

/** Index saHpiDomainId is external */
/** Index saHpiResourceId is external */
/** Index saHpiResourceIsHistorical is external */
/** Index saHpiSensorNum is external */

typedef struct saHpiSensorReadingNormalMinTable_context_s {
	netsnmp_index index; /** THIS MUST BE FIRST!!! */

	/*************************************************************
	 * You can store data internally in this structure.
	 *
	 * TODO: You will probably have to fix a few types here...
	 */
	/** TODO: add storage for external index(s)! */
	/** TruthValue = ASN_INTEGER */
	long saHpiSensorReadingNormalMinIsSupported;

	/** SaHpiSensorReadingType = ASN_INTEGER */
	long saHpiSensorReadingNormalMinType;

	/** SaHpiSensorReadingValue = ASN_OCTET_STR */
	unsigned char saHpiSensorReadingNormalMinValue[SAHPI_SENSOR_BUFFER_LENGTH];
	long saHpiSensorReadingNormalMinValue_len;


	/*
	 * OR
	 *
	 * Keep a pointer to your data
	 */
	void * data;

	/*
	 *add anything else you want here
	 */

} saHpiSensorReadingNormalMinTable_context;

/*
 * SaErrorT populate_sensor_max()
 */
SaErrorT populate_sensor_normal_min(SaHpiSessionIdT sessionid, 
					    SaHpiRdrT *rdr_entry,
					    SaHpiRptEntryT *rpt_entry);
SaErrorT clear_sensor_normal_min(SaHpiDomainIdT domainId, 
                              SaHpiResourceIdT resourceId);

/*************************************************************
 * function declarations
 */
void init_saHpiSensorReadingNormalMinTable(void);
void initialize_table_saHpiSensorReadingNormalMinTable(void);
const saHpiSensorReadingNormalMinTable_context * saHpiSensorReadingNormalMinTable_get_by_idx(netsnmp_index *);
const saHpiSensorReadingNormalMinTable_context * saHpiSensorReadingNormalMinTable_get_by_idx_rs(netsnmp_index *,
												int row_status);
int saHpiSensorReadingNormalMinTable_get_value(netsnmp_request_info *, netsnmp_index *, netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
extern oid saHpiSensorReadingNormalMinTable_oid[];
extern size_t saHpiSensorReadingNormalMinTable_oid_len;

#define saHpiSensorReadingNormalMinTable_TABLE_OID 1,3,6,1,4,1,18568,2,1,1,4,9,8

/* Number of table Indexes */
#define SENSOR_READING_NORMAL_MIN_INDEX_NR 4 
#define saHpiSenNormMinDomainId_INDEX 0
#define saHpiSenNormMinResourceId_INDEX 1
#define saHpiSenNormMinResourceIsHistorical_INDEX 2
#define saHpiSensorNormMinNum_INDEX 3


/*************************************************************
 * column number definitions for table saHpiSensorReadingNormalMinTable
 */
#define COLUMN_SAHPISENSORREADINGNORMALMINISSUPPORTED 1
#define COLUMN_SAHPISENSORREADINGNORMALMINTYPE 2
#define COLUMN_SAHPISENSORREADINGNORMALMINVALUE 3
#define saHpiSensorReadingNormalMinTable_COL_MIN 1
#define saHpiSensorReadingNormalMinTable_COL_MAX 3

int saHpiSensorReadingNormalMinTable_extract_index( saHpiSensorReadingNormalMinTable_context * ctx, netsnmp_index * hdr );

void saHpiSensorReadingNormalMinTable_set_reserve1( netsnmp_request_group * );
void saHpiSensorReadingNormalMinTable_set_reserve2( netsnmp_request_group * );
void saHpiSensorReadingNormalMinTable_set_action( netsnmp_request_group * );
void saHpiSensorReadingNormalMinTable_set_commit( netsnmp_request_group * );
void saHpiSensorReadingNormalMinTable_set_free( netsnmp_request_group * );
void saHpiSensorReadingNormalMinTable_set_undo( netsnmp_request_group * );

saHpiSensorReadingNormalMinTable_context * saHpiSensorReadingNormalMinTable_duplicate_row( saHpiSensorReadingNormalMinTable_context* );
netsnmp_index * saHpiSensorReadingNormalMinTable_delete_row( saHpiSensorReadingNormalMinTable_context* );

int saHpiSensorReadingNormalMinTable_can_activate(saHpiSensorReadingNormalMinTable_context *undo_ctx,
						  saHpiSensorReadingNormalMinTable_context *row_ctx,
						  netsnmp_request_group * rg);
int saHpiSensorReadingNormalMinTable_can_deactivate(saHpiSensorReadingNormalMinTable_context *undo_ctx,
						    saHpiSensorReadingNormalMinTable_context *row_ctx,
						    netsnmp_request_group * rg);
int saHpiSensorReadingNormalMinTable_can_delete(saHpiSensorReadingNormalMinTable_context *undo_ctx,
						saHpiSensorReadingNormalMinTable_context *row_ctx,
						netsnmp_request_group * rg);


saHpiSensorReadingNormalMinTable_context * saHpiSensorReadingNormalMinTable_create_row( netsnmp_index* );

saHpiSensorReadingNormalMinTable_context * saHpiSensorReadingNormalMinTable_get( const char *name, int len );

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORREADINGNORMALMINTABLE_H */
