/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiSensorThdUpMajorTable.h 5354 2005-10-05 15:36:19Z ddearauj $
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#ifndef SAHPISENSORTHDUPMAJORTABLE_H
#define SAHPISENSORTHDUPMAJORTABLE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>

/** Index saHpiDomainId is external */
/** Index saHpiResourceId is external */
/** Index saHpiResourceIsHistorical is external */
/** Index saHpiSensorNum is external */

typedef struct saHpiSensorThdUpMajorTable_context_s {
        netsnmp_index index; /** THIS MUST BE FIRST!!! */

        /*************************************************************
         * You can store data internally in this structure.
         *
         * TODO: You will probably have to fix a few types here...
         */
        /** TODO: add storage for external index(s)! */
        /** TruthValue = ASN_INTEGER */
        long saHpiSensorThdUpMajorIsReadable;

        /** TruthValue = ASN_INTEGER */
        long saHpiSensorThdUpMajorIsWritable;

        /** SaHpiSensorReadingType = ASN_INTEGER */
        long saHpiSensorThdUpMajorType;

        /** SaHpiSensorReadingValue = ASN_OCTET_STR */
        unsigned char saHpiSensorThdUpMajorValue[SAHPI_SENSOR_BUFFER_LENGTH];
        long saHpiSensorThdUpMajorValue_len;

        /** TruthValue = ASN_INTEGER */
        long saHpiSensorThdUpMajorNonLinear;


        /*
         * OR
         *
         * Keep a pointer to your data
         */
        void * data;

        /*
         *add anything else you want here
         */

} saHpiSensorThdUpMajorTable_context;  

/*************************************************************
 * function declarations
 */
SaErrorT populate_sen_thd_up_major(SaHpiSessionIdT sessionid, 
                                           SaHpiRdrT *rdr_entry,
                                           SaHpiRptEntryT *rpt_entry,
                                           SaHpiSensorThresholdsT *sensor_thresholds);
SaErrorT clear_sen_thd_up_major(SaHpiDomainIdT domainId, 
                                SaHpiResourceIdT resourceId);
int set_table_sen_thds_up_major (saHpiSensorThdUpMajorTable_context *row_ctx);

/*************************************************************
 * function declarations
 */
void init_saHpiSensorThdUpMajorTable(void);
void initialize_table_saHpiSensorThdUpMajorTable(void);
const saHpiSensorThdUpMajorTable_context * saHpiSensorThdUpMajorTable_get_by_idx(netsnmp_index *);
const saHpiSensorThdUpMajorTable_context * saHpiSensorThdUpMajorTable_get_by_idx_rs(netsnmp_index *,
                                                                                    int row_status);
int saHpiSensorThdUpMajorTable_get_value(netsnmp_request_info *, netsnmp_index *, netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
extern oid saHpiSensorThdUpMajorTable_oid[];
extern size_t saHpiSensorThdUpMajorTable_oid_len;

#define saHpiSensorThdUpMajorTable_TABLE_OID 1,3,6,1,4,1,18568,2,1,1,4,9,13

/* Number of table Indexes */
#define SEN_THD_UP_MAJOR_IDX_NR 4
#define saHpiThdUpMajDomainId_INDEX 0
#define saHpiThdUpMajResourceEntryId_INDEX 1
#define saHpiThdUpMajResourceIsHistorical_INDEX 2
#define saHpiSensorThdUpMajNum_INDEX 3

/*************************************************************
 * column number definitions for table saHpiSensorThdUpMajorTable
 */
#define COLUMN_SAHPISENSORTHDUPMAJORISREADABLE 1
#define COLUMN_SAHPISENSORTHDUPMAJORISWRITABLE 2
#define COLUMN_SAHPISENSORTHDUPMAJORTYPE 3
#define COLUMN_SAHPISENSORTHDUPMAJORVALUE 4
#define COLUMN_SAHPISENSORTHDUPMAJORNONLINEAR 5
#define saHpiSensorThdUpMajorTable_COL_MIN 1
#define saHpiSensorThdUpMajorTable_COL_MAX 5

int saHpiSensorThdUpMajorTable_extract_index( saHpiSensorThdUpMajorTable_context * ctx, netsnmp_index * hdr );

void saHpiSensorThdUpMajorTable_set_reserve1( netsnmp_request_group * );
void saHpiSensorThdUpMajorTable_set_reserve2( netsnmp_request_group * );
void saHpiSensorThdUpMajorTable_set_action( netsnmp_request_group * );
void saHpiSensorThdUpMajorTable_set_commit( netsnmp_request_group * );
void saHpiSensorThdUpMajorTable_set_free( netsnmp_request_group * );
void saHpiSensorThdUpMajorTable_set_undo( netsnmp_request_group * );

saHpiSensorThdUpMajorTable_context * saHpiSensorThdUpMajorTable_duplicate_row( saHpiSensorThdUpMajorTable_context* );
netsnmp_index * saHpiSensorThdUpMajorTable_delete_row( saHpiSensorThdUpMajorTable_context* );

int saHpiSensorThdUpMajorTable_can_activate(saHpiSensorThdUpMajorTable_context *undo_ctx,
                                            saHpiSensorThdUpMajorTable_context *row_ctx,
                                            netsnmp_request_group * rg);
int saHpiSensorThdUpMajorTable_can_deactivate(saHpiSensorThdUpMajorTable_context *undo_ctx,
                                              saHpiSensorThdUpMajorTable_context *row_ctx,
                                              netsnmp_request_group * rg);
int saHpiSensorThdUpMajorTable_can_delete(saHpiSensorThdUpMajorTable_context *undo_ctx,
                                          saHpiSensorThdUpMajorTable_context *row_ctx,
                                          netsnmp_request_group * rg);


saHpiSensorThdUpMajorTable_context * saHpiSensorThdUpMajorTable_create_row( netsnmp_index* );

saHpiSensorThdUpMajorTable_context * saHpiSensorThdUpMajorTable_get( const char *name, int len );

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORTHDUPMAJORTABLE_H */
