/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiSoftwareEventLogTable.h 5405 2005-11-09 22:14:23Z ddearauj $
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#ifndef SAHPISOFTWAREEVENTLOGTABLE_H
#define SAHPISOFTWAREEVENTLOGTABLE_H

#ifdef __cplusplus
extern "C" {
#endif

    
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>

#include <hpiSubagent.h>
        /** Index saHpiDomainId is external */
        /** Index saHpiResourceId is external */
        /** Index saHpiEventSeverity is external */
        /** Index saHpiSoftwareEventEntryId is external */

typedef struct saHpiSoftwareEventLogTable_context_s {
    netsnmp_index index; /** THIS MUST BE FIRST!!! */

    /*************************************************************
     * You can store data internally in this structure.
     *
     * TODO: You will probably have to fix a few types here...
     */
    /** TODO: add storage for external index(s)! */
        /** SaHpiTime = ASN_OCTET_STR */
            unsigned char saHpiSoftwareEventLogTimestamp[SAF_UNSIGNED_64_LEN];
	    long saHpiSoftwareEventLogTimestamp_len;

        /** SaHpiManufacturerId = ASN_UNSIGNED */
            unsigned long saHpiSoftwareEventLogManufacturerIdT;

        /** INTEGER = ASN_INTEGER */
            long saHpiSoftwareEventLogType;

        /** SaHpiTextType = ASN_INTEGER */
            long saHpiSoftwareEventLogTextType;

        /** SaHpiTextLanguage = ASN_INTEGER */
            long saHpiSoftwareEventLogTextLanguage;

        /** SaHpiText = ASN_OCTET_STR */
            unsigned char saHpiSoftwareEventLogText[SAHPI_MAX_TEXT_BUFFER_LENGTH];
            long saHpiSoftwareEventLogText_len;


    /*
     * OR
     *
     * Keep a pointer to your data
     */
    void * data;

    /*
     *add anything else you want here
     */

} saHpiSoftwareEventLogTable_context;

/*************************************************************
 * function declarations
 */
void init_saHpiSoftwareEventLogTable(void);
void initialize_table_saHpiSoftwareEventLogTable(void);
const saHpiSoftwareEventLogTable_context * saHpiSoftwareEventLogTable_get_by_idx(netsnmp_index *);
const saHpiSoftwareEventLogTable_context * saHpiSoftwareEventLogTable_get_by_idx_rs(netsnmp_index *,
                                        int row_status);
int saHpiSoftwareEventLogTable_get_value(netsnmp_request_info *, netsnmp_index *, netsnmp_table_request_info *);


/*************************************************************
 * function declarations
 */
SaErrorT populate_saHpiSoftwareEventLogTable(SaHpiSessionIdT sessionid, 
                                             SaHpiEventLogEntryT *event,
                                             oid * this_child_oid, 
                                             size_t *this_child_oid_len);

SaErrorT software_event_log_clear(SaHpiSessionIdT session_id, 
                                  SaHpiResourceIdT resource_id,  
                                  oid *saHpiEventLogRowPointer, 
                                  size_t saHpiEventLogRowPointer_len,
				  int modifyTotal);


/*************************************************************
 * oid declarations
 */
extern oid saHpiSoftwareEventLogTable_oid[];
extern size_t saHpiSoftwareEventLogTable_oid_len;

#define saHpiSoftwareEventLogTable_TABLE_OID 1,3,6,1,4,1,18568,2,1,1,3,2,23
    
/*************************************************************
 * column number definitions for table saHpiSoftwareEventLogTable
 */
#define SOFTWARE_EVENT_LOG_INDEX_NR 4
#define COLUMN_SAHPISOFTWAREEVENTLOGTIMESTAMP 1
#define COLUMN_SAHPISOFTWAREEVENTLOGMANUFACTURERIDT 2
#define COLUMN_SAHPISOFTWAREEVENTLOGTYPE 3
#define COLUMN_SAHPISOFTWAREEVENTLOGTEXTTYPE 4
#define COLUMN_SAHPISOFTWAREEVENTLOGTEXTLANGUAGE 5
#define COLUMN_SAHPISOFTWAREEVENTLOGTEXT 6
#define saHpiSoftwareEventLogTable_COL_MIN 1
#define saHpiSoftwareEventLogTable_COL_MAX 6

/* comment out the following line if you don't handle SET-REQUEST for saHpiSoftwareEventLogTable */
#define saHpiSoftwareEventLogTable_SET_HANDLING

/* comment out the following line if you can't create new rows */
#define saHpiSoftwareEventLogTable_ROW_CREATION

/* comment out the following line if you don't want the secondary index */
#define saHpiSoftwareEventLogTable_IDX2

/* uncommend the following line if you allow modifications to an
 * active row */
/** define saHpiSoftwareEventLogTable_CAN_MODIFY_ACTIVE_ROW */

#ifdef saHpiSoftwareEventLogTable_SET_HANDLING

int saHpiSoftwareEventLogTable_extract_index( saHpiSoftwareEventLogTable_context * ctx, netsnmp_index * hdr );

void saHpiSoftwareEventLogTable_set_reserve1( netsnmp_request_group * );
void saHpiSoftwareEventLogTable_set_reserve2( netsnmp_request_group * );
void saHpiSoftwareEventLogTable_set_action( netsnmp_request_group * );
void saHpiSoftwareEventLogTable_set_commit( netsnmp_request_group * );
void saHpiSoftwareEventLogTable_set_free( netsnmp_request_group * );
void saHpiSoftwareEventLogTable_set_undo( netsnmp_request_group * );

saHpiSoftwareEventLogTable_context * saHpiSoftwareEventLogTable_duplicate_row( saHpiSoftwareEventLogTable_context* );
netsnmp_index * saHpiSoftwareEventLogTable_delete_row( saHpiSoftwareEventLogTable_context* );

int saHpiSoftwareEventLogTable_can_activate(saHpiSoftwareEventLogTable_context *undo_ctx,
                      saHpiSoftwareEventLogTable_context *row_ctx,
                      netsnmp_request_group * rg);
int saHpiSoftwareEventLogTable_can_deactivate(saHpiSoftwareEventLogTable_context *undo_ctx,
                        saHpiSoftwareEventLogTable_context *row_ctx,
                        netsnmp_request_group * rg);
int saHpiSoftwareEventLogTable_can_delete(saHpiSoftwareEventLogTable_context *undo_ctx,
                    saHpiSoftwareEventLogTable_context *row_ctx,
                    netsnmp_request_group * rg);
    
    
#ifdef saHpiSoftwareEventLogTable_ROW_CREATION
saHpiSoftwareEventLogTable_context * saHpiSoftwareEventLogTable_create_row( netsnmp_index* );
#endif
#endif

#ifdef saHpiSoftwareEventLogTable_IDX2
saHpiSoftwareEventLogTable_context * saHpiSoftwareEventLogTable_get( const char *name, int len );
#endif

#ifdef __cplusplus
};
#endif

#endif /** SAHPISOFTWAREEVENTLOGTABLE_H */
