/*
 * (C) Copyright IBM Corp. 2005
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   David Judkovics  <djudkovi@us.ibm.com>
 *   Daniel de Araujo <ddearauj@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *       : mib2c.array-user.conf,v 5.18.2.2 2004/02/09 18:21:47 rstory Exp $
 *
 * $Id: saHpiSensorEnableChangeEventLogTable.c 5421 2005-11-14 21:02:01Z djudkovi $
 *
 *
 * For help understanding NET-SNMP in general, please check the 
 *     documentation and FAQ at:
 *
 *     http://www.net-snmp.org/
 *
 *
 * For help understanding this code, the agent and how it processes
 *     requests, please check the following references.
 *
 *     http://www.net-snmp.org/tutorial-5/
 *
 *
 * You can also join the #net-snmp channel on irc.freenode.net
 *     and ask for help there.
 *
 *
 * And if all else fails, send a detailed message to the developers
 *     describing the problem you are having to:
 *
 *    net-snmp-coders@lists.sourceforge.net
 *
 *
 * Yes, there is lots of code here that you might not use. But it is much
 * easier to remove code than to add it!
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#include <net-snmp/library/snmp_assert.h>

#include <SaHpi.h>
#include "saHpiSensorEnableChangeEventLogTable.h"
#include <hpiSubagent.h>
#include <hpiCheckIndice.h>
#include <session_info.h>
#include <oh_utils.h>
#include <hpiLock.h>

static     netsnmp_handler_registration *my_handler = NULL;
static     netsnmp_table_array_callbacks cb;

oid saHpiSensorEnableChangeEventLogTable_oid[] = { saHpiSensorEnableChangeEventLogTable_TABLE_OID };
size_t saHpiSensorEnableChangeEventLogTable_oid_len = OID_LENGTH(saHpiSensorEnableChangeEventLogTable_oid);

/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/

/*************************************************************
 * objects for hash table
 */
static int initialized = FALSE;		      
static GHashTable *dr_table;

/*************************************************************
 * oid and function declarations scalars
 */
 
static u_long sensor_enable_change_event_log_entry_count_total = 0;
static u_long sensor_enable_change_event_log_entry_count = 0;


static oid saHpiSensorEnableChangeEventLogLifetimeChanges_oid[] = { 1,3,6,1,4,1,18568,2,1,1,3,2,12 };
static oid saHpiSensorEnableChangeEventLogActiveEntries_oid[] = { 1,3,6,1,4,1,18568,2,1,1,3,2,13 };

int handle_saHpiSensorEnableChangeEventLogLifetimeChanges(netsnmp_mib_handler *handler,
                                        netsnmp_handler_registration *reginfo,
                                        netsnmp_agent_request_info   *reqinfo,
                                        netsnmp_request_info         *requests);

int handle_saHpiSensorEnableChangeEventLogActiveEntries(netsnmp_mib_handler *handler,
                                        netsnmp_handler_registration *reginfo,
                                        netsnmp_agent_request_info   *reqinfo,
                                        netsnmp_request_info         *requests);

int initialize_table_saHpiSensorEnableChangeEventLogLifetimeChanges(void);
int initialize_table_saHpiSensorEnableChangeEventLogActiveEntries(void);


SaErrorT populate_saHpiSensorEnableChangeEventLogTable(SaHpiSessionIdT sessionid, 
                                             SaHpiEventLogEntryT *event,
                                             oid * this_child_oid, 
                                             size_t *this_child_oid_len)
{
	SaErrorT rv = SA_OK;

	oid sec_evt_oid[SENSOR_ENABLE_CHANGE_EVENT_LOG_INDEX_NR];
	netsnmp_index sec_evt_idx;
	saHpiSensorEnableChangeEventLogTable_context *sec_evt_ctx;
	SaHpiTextBufferT sec_text_buf;
	SaErrorT err = 0;	

	oid column[2];
	int column_len = 2;
	
	int isNewRow = MIB_TRUE;

        DR_XREF *dr_entry;
	SaHpiDomainIdResourceIdArrayT dr_pair;

        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable, called\n"));

	/* check for NULL pointers */
	if (!event) {
		DEBUGMSGTL ((AGENT, 
		"ERROR: populate_saHpiSensorEnableChangeEventLogTable() passed NULL event pointer\n"));
		return AGENT_ERR_INTERNAL_ERROR;
	}    

	subagent_lock(&hpi_lock_data);
	
	/* BUILD oid for new row */
		/* assign the number of indices */
	sec_evt_idx.len = SENSOR_ENABLE_CHANGE_EVENT_LOG_INDEX_NR;
		/** Index saHpiDomainId is external */
	sec_evt_oid[0] = get_domain_id(sessionid);
		/** Index saHpiResourceId is external */
	sec_evt_oid[1] = event->Event.Source;		
                /** Index saHpiSensorNum is external */
	sec_evt_oid[2] = event->Event.EventDataUnion.SensorEnableChangeEvent.SensorNum;
		/** Index saHpiEventSeverity is external */
	sec_evt_oid[3] = event->Event.Severity + 1;		
                /** Index saHpiSensorEnableChangeEventEntryId is external */
	dr_pair.domainId_resourceId_arry[0] = get_domain_id(sessionid);
	dr_pair.domainId_resourceId_arry[1] = event->Event.Source;
	dr_entry = domain_resource_pair_get(&dr_pair, &dr_table); 
	if (dr_entry == NULL) {
		DEBUGMSGTL ((AGENT, 
		"ERROR: populate_saHpiSensorEnableChangeEventLogTable() domain_resource_pair_get returned NULL\n"));
		subagent_unlock(&hpi_lock_data);
		return AGENT_ERR_INTERNAL_ERROR;
	}
	sec_evt_oid[4] = dr_entry->entry_id++;
		/* assign the indices to the index */
	sec_evt_idx.oids = (oid *) & sec_evt_oid;
	
	/* create full oid on This row for parent RowPointer */
	column[0] = 1;
	column[1] = COLUMN_SAHPISENSORENABLECHANGEEVENTLOGTIMESTAMP;
	memset(this_child_oid, 0, sizeof(this_child_oid));
	build_full_oid(saHpiSensorEnableChangeEventLogTable_oid, saHpiSensorEnableChangeEventLogTable_oid_len,
			column, column_len,
			&sec_evt_idx,
			this_child_oid, MAX_OID_LEN, this_child_oid_len);	

	/* See if Row exists. */
	sec_evt_ctx = NULL;
	sec_evt_ctx = CONTAINER_FIND(cb.container, &sec_evt_idx);

	if (!sec_evt_ctx) { 
		// New entry. Add it
		sec_evt_ctx = 
			saHpiSensorEnableChangeEventLogTable_create_row(&sec_evt_idx);
	}
	else {
		isNewRow = MIB_FALSE;
	}
		
	if (!sec_evt_ctx) {
		snmp_log (LOG_ERR, "Not enough memory for a Sensor Enable Change Event Log row!");
		rv = AGENT_ERR_INTERNAL_ERROR;
	}


        /** SaHpiTime = ASN_OCTET_STR */
	hpitime_to_snmptime(event->Timestamp, sec_evt_ctx->saHpiSensorEnableChangeEventLogTimestamp);
        sec_evt_ctx->saHpiSensorEnableChangeEventLogTimestamp_len = sizeof(SaHpiTimeT);
        /** SaHpiSensorType = ASN_INTEGER */	
	sec_evt_ctx->saHpiSensorEnableChangeEventLogType = 
	        event->Event.EventDataUnion.SensorEnableChangeEvent.SensorType + 1;
	
        /** SaHpiEventCategory = ASN_INTEGER */
	sec_evt_ctx->saHpiSensorEnableChangeEventLogCategory =
	        event->Event.EventDataUnion.SensorEnableChangeEvent.EventCategory;
		
        /** TruthValue = ASN_INTEGER */
	sec_evt_ctx->saHpiSensorEnableChangeEventLogEnabled = 
	        event->Event.EventDataUnion.SensorEnableChangeEvent.SensorEnable;
	
        /** TruthValue = ASN_INTEGER */
	sec_evt_ctx->saHpiSensorEnableChangeEventLogEventsEnabled =
	        event->Event.EventDataUnion.SensorEnableChangeEvent.SensorEventEnable;
	
       /** SaHpiEventState = ASN_OCTET_STR */	
	err = oh_decode_eventstate(event->Event.EventDataUnion.SensorEnableChangeEvent.AssertEventMask,
	                           sec_evt_ctx->saHpiSensorEnableChangeEventLogCategory,
				   &sec_text_buf);
	if (err != SA_OK)
	{
	        if (err == SA_ERR_HPI_INVALID_PARAMS)
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Invalid parameter for AssertEventMask\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is NULL; Invalid event_state or event_cat");
		}
		else if (err == SA_ERR_HPI_OUT_OF_SPACE) 
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is too small for AssertEventMask\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer too small");
                }
		else
		{
			DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error");
		}
	}	

	sec_evt_ctx->saHpiSensorEnableChangeEventLogAssertEvents_len = 
	                                        sec_text_buf.DataLength;	
	memcpy(sec_evt_ctx->saHpiSensorEnableChangeEventLogAssertEvents, 
	                                        sec_text_buf.Data,
					        sec_text_buf.DataLength);

        /** SaHpiEventState = ASN_OCTET_STR */	
	err = oh_decode_eventstate(event->Event.EventDataUnion.SensorEnableChangeEvent.DeassertEventMask,
	                           sec_evt_ctx->saHpiSensorEnableChangeEventLogCategory,
				   &sec_text_buf);
	if (err != SA_OK)
	{
	        if (err == SA_ERR_HPI_INVALID_PARAMS)
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Invalid parameter for DeassertEventMask\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is NULL; Invalid event_state or event_cat");
		}
		else if (err == SA_ERR_HPI_OUT_OF_SPACE) 
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is too small for DeassertEventMask\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer too small");
                }
		else
		{
			DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error");
		}
	}	

	sec_evt_ctx->saHpiSensorEnableChangeEventLogDeassertEvents_len = 
	                                        sec_text_buf.DataLength;	
	memcpy(sec_evt_ctx->saHpiSensorEnableChangeEventLogDeassertEvents, 
	                                        sec_text_buf.Data,
					        sec_text_buf.DataLength);  
						
	
	/** SaHpiOptionalData = ASN_OCTET_STR */						
	err = oh_decode_sensorenableoptdata(
	                        event->Event.EventDataUnion.SensorEnableChangeEvent.OptionalDataPresent,	                           
				&sec_text_buf);
				
	if (err != SA_OK)
	{
	        if (err == SA_ERR_HPI_INVALID_PARAMS)
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Invalid parameter for OptionalData\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is NULL; Invalid event_state or event_cat");
		}
		else
		{
			DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error");
		}
	}
						
	sec_evt_ctx->saHpiSensorEnableChangeEventLogOptionalData_len 
	                                        = sec_text_buf.DataLength;
	memcpy(sec_evt_ctx->saHpiSensorEnableChangeEventLogOptionalData, 
	                                        sec_text_buf.Data,
					        sec_text_buf.DataLength);								


        /** SaHpiEventState = ASN_OCTET_STR */	
	err = oh_decode_eventstate(event->Event.EventDataUnion.SensorEnableChangeEvent.CurrentState,
	                           sec_evt_ctx->saHpiSensorEnableChangeEventLogCategory,
				   &sec_text_buf);
	if (err != SA_OK)
	{
	        if (err == SA_ERR_HPI_INVALID_PARAMS)
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Invalid parameter for CurrentState\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is NULL; Invalid event_state or event_cat");
		}
		else if (err == SA_ERR_HPI_OUT_OF_SPACE) 
		{
		        DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Buffer is too small for CurrentState\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Buffer too small");
                }
		else
		{
			DEBUGMSGTL ((AGENT, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error\n"));
			snmp_log (LOG_ERR, "populate_saHpiSensorEnableChangeEventLogTable: Unknown error");
		}
	}	

	sec_evt_ctx->saHpiSensorEnableChangeEventLogState_len = 
	                                        sec_text_buf.DataLength;	
	memcpy(sec_evt_ctx->saHpiSensorEnableChangeEventLogState, 
	                                        sec_text_buf.Data,
					        sec_text_buf.DataLength);



	if (isNewRow == MIB_TRUE) {
		CONTAINER_INSERT (cb.container, sec_evt_ctx);
	}
		
	sensor_enable_change_event_log_entry_count = CONTAINER_SIZE (cb.container);

        subagent_unlock(&hpi_lock_data);
	
	return SA_OK;
}

/**
 * 
 * @session_id
 * @resource_id
 * @saHpiEventLogRowPointer
 * @aHpiEventLogRowPointer_len
 * 
 * @return 
 */
SaErrorT sen_en_change_event_log_clear(SaHpiSessionIdT session_id, 
                                      SaHpiResourceIdT resource_id,  
                                      oid *saHpiEventLogRowPointer, 
                                      size_t saHpiEventLogRowPointer_len,
				      int modifyTotal)
{
	oid sec_evt_oid[SENSOR_ENABLE_CHANGE_EVENT_LOG_INDEX_NR];
	netsnmp_index sec_evt_idx;
	netsnmp_index *sec_index;
	saHpiSensorEnableChangeEventLogTable_context *sec_evt_ctx;
	
	DR_XREF *dr_entry;
	SaHpiDomainIdResourceIdArrayT dr_pair;	

	int column_len = 2;
	
        DEBUGMSGTL ((AGENT, "sen_en_change_event_log_clear, called\n"));
	DEBUGMSGTL ((AGENT, "Attempting to delete sensor el row with the following indexes:\n"));
        DEBUGMSGTL ((AGENT,"     Domain   [%ld]\n", saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len]));
        DEBUGMSGTL ((AGENT,"     Resource [%ld]\n", saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 1]));
	DEBUGMSGTL ((AGENT,"     Sensor # [%ld]\n", saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 2])); 
	DEBUGMSGTL ((AGENT,"     Severity [%s]\n",  oh_lookup_severity(
						saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 3]-1)));	
	DEBUGMSGTL ((AGENT,"     Entry id [%ld]\n",	saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 4]));

	/* BUILD oid for new row */
		/* assign the number of indices */
	sec_evt_idx.len = SENSOR_ENABLE_CHANGE_EVENT_LOG_INDEX_NR;
		/** Index saHpiDomainId is external */
	sec_evt_oid[0] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len];
		/** Index saHpiResourceId is external */
	sec_evt_oid[1] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 1];		
                /** Index saHpiSensorNum is external */
	sec_evt_oid[2] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 2];
		/** Index saHpiEventSeverity is external */
	sec_evt_oid[3] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 3];		
                /** Index saHpiSensorEnableChangeEventEntryId is external */
	sec_evt_oid[4] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 4];
		/* assign the indices to the index */
	sec_evt_idx.oids = (oid *) & sec_evt_oid;
	
	sec_index = CONTAINER_FIRST(cb.container);
	sec_evt_ctx = CONTAINER_FIND(cb.container, &sec_evt_idx);
	
	if (!sec_evt_ctx) {
		DEBUGMSGTL ((AGENT, "sen_en_change_event_log_clear did not find a row to delete\n"));
	}
	else {
		
		DEBUGMSGTL ((AGENT, "sen_en_change_event_log_clear found row to delete\n"));
		CONTAINER_REMOVE(cb.container, sec_evt_ctx);
		saHpiSensorEnableChangeEventLogTable_delete_row(sec_evt_ctx);
		
		/* Reset the entry id for this domain/resource pair */
		dr_pair.domainId_resourceId_arry[0] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len];
		dr_pair.domainId_resourceId_arry[1] = saHpiEventLogRowPointer[saHpiSensorEnableChangeEventLogTable_oid_len + column_len + 1];
		dr_entry = domain_resoruce_pair_lookup(&dr_pair, &dr_table); 
		
		if (dr_entry == NULL) {
			DEBUGMSGTL ((AGENT, 
			"ERROR: sen_en_change_event_log_clear() domain_resoruce_pair_lookup returned NULL\n"));
			return AGENT_ERR_INTERNAL_ERROR;
		}
	
		DEBUGMSGTL ((AGENT, 
			"sen_en_change_event_log_clear() resetting entry_id to 0\n"));
		dr_entry->entry_id = 0;		
		
		sensor_enable_change_event_log_entry_count = CONTAINER_SIZE (cb.container);
		
		if (modifyTotal == MIB_TRUE) {		
			sensor_enable_change_event_log_entry_count_total--;	
		}	
	}	
	
	
	
        return SA_OK;
}

/**
 * 
 * @handler:
 * @reginfo:
 * @reqinfo:
 * @requests:
 * 
 * @return:
 */
int
handle_saHpiSensorEnableChangeEventLogLifetimeChanges(netsnmp_mib_handler *handler,
                                        netsnmp_handler_registration *reginfo,
                                        netsnmp_agent_request_info   *reqinfo,
                                        netsnmp_request_info         *requests)
{
        /* We are never called for a GETNEXT if it's registered as a
           "instance", as it's "magically" handled for us.  */
        /* a instance handler also only hands us one request at a time, so
           we don't need to loop over a list of requests; we'll only get one. */
        
        DEBUGMSGTL ((AGENT, "handle_saHpiSensorEnableChangeEventLogLifetimeChanges, called\n"));

        switch(reqinfo->mode) {

        case MODE_GET:
                snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER,
        			(u_char *) &sensor_enable_change_event_log_entry_count_total,
        			sizeof(sensor_enable_change_event_log_entry_count_total));
                break;


        default:
                /* we should never get here, so this is a really bad error */
                return SNMP_ERR_GENERR;
        }

        return SNMP_ERR_NOERROR;
} 
 
/**
 * 
 * @handler:
 * @reginfo:
 * @reqinfo:
 * @requests:
 * 
 * @return:
 */
int
handle_saHpiSensorEnableChangeEventLogActiveEntries(netsnmp_mib_handler *handler,
                                        netsnmp_handler_registration *reginfo,
                                        netsnmp_agent_request_info   *reqinfo,
                                        netsnmp_request_info         *requests)
{
        /* We are never called for a GETNEXT if it's registered as a
           "instance", as it's "magically" handled for us.  */
        /* a instance handler also only hands us one request at a time, so
           we don't need to loop over a list of requests; we'll only get one. */

        DEBUGMSGTL ((AGENT, "handle_saHpiSensorEnableChangeEventLogActiveEntries, called\n"));

        sensor_enable_change_event_log_entry_count = CONTAINER_SIZE (cb.container);
        
        switch(reqinfo->mode) {

        case MODE_GET:
                snmp_set_var_typed_value(requests->requestvb, ASN_GAUGE,
        			        (u_char *) &sensor_enable_change_event_log_entry_count,
        			        sizeof(sensor_enable_change_event_log_entry_count));
                break;


        default:
                /* we should never get here, so this is a really bad error */
                return SNMP_ERR_GENERR;
        }

        return SNMP_ERR_NOERROR;
}

 
/**
 * 
 * @return: 
 */
int initialize_table_saHpiSensorEnableChangeEventLogLifetimeChanges(void)
{

        DEBUGMSGTL ((AGENT, "initialize_table_saHpiSensorEnableChangeEventLogLifetimeChanges, called\n"));

        netsnmp_register_scalar(
                                netsnmp_create_handler_registration(
				        "saHpiSensorEnableChangeEventLogLifetimeChanges", 
					handle_saHpiSensorEnableChangeEventLogLifetimeChanges,
                                        saHpiSensorEnableChangeEventLogLifetimeChanges_oid, 
					OID_LENGTH(saHpiSensorEnableChangeEventLogLifetimeChanges_oid),
                                        HANDLER_CAN_RONLY ));

        return SNMP_ERR_NOERROR;
} 

/**
 * 
 * @return: 
 */   
int initialize_table_saHpiSensorEnableChangeEventLogActiveEntries(void)
{

        DEBUGMSGTL ((AGENT, "initialize_table_saHpiSensorEnableChangeEventLogActiveEntries, called\n"));

        netsnmp_register_scalar(
                                netsnmp_create_handler_registration(
				        "saHpiSensorEnableChangeEventLogActiveEntries", 
					handle_saHpiSensorEnableChangeEventLogActiveEntries,
                                        saHpiSensorEnableChangeEventLogActiveEntries_oid, 
					OID_LENGTH(saHpiSensorEnableChangeEventLogActiveEntries_oid),
                                        HANDLER_CAN_RONLY ));

        return SNMP_ERR_NOERROR;
}

/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
 

/************************************************************
 * keep binary tree to find context by name
 */
static int saHpiSensorEnableChangeEventLogTable_cmp( const void *lhs, const void *rhs );

/************************************************************
 * compare two context pointers here. Return -1 if lhs < rhs,
 * 0 if lhs == rhs, and 1 if lhs > rhs.
 */
static int
saHpiSensorEnableChangeEventLogTable_cmp( const void *lhs, const void *rhs )
{
        saHpiSensorEnableChangeEventLogTable_context *context_l =
        (saHpiSensorEnableChangeEventLogTable_context *)lhs;
        saHpiSensorEnableChangeEventLogTable_context *context_r =
        (saHpiSensorEnableChangeEventLogTable_context *)rhs;

        /*
         * check primary key, then secondary. Add your own code if
         * there are more than 2 indexes
         */
        DEBUGMSGTL ((AGENT, "saHpiSensorEnableChangeEventLogTable_cmp, called\n"));

        /* check for NULL pointers */
        if (lhs == NULL || rhs == NULL ) {
                DEBUGMSGTL((AGENT,"saHpiSensorEnableChangeEventLogTable_cmp() NULL pointer ERROR\n" ));
                return 0;
        }
        /* CHECK FIRST INDEX,  saHpiDomainId */
        if ( context_l->index.oids[0] < context_r->index.oids[0])
                return -1;

        if ( context_l->index.oids[0] > context_r->index.oids[0])
                return 1;

        if ( context_l->index.oids[0] == context_r->index.oids[0]) {
                /* If saHpiDomainId index is equal sort by second index */
                /* CHECK SECOND INDEX,  saHpiResourceEntryId */
                if ( context_l->index.oids[1] < context_r->index.oids[1])
                        return -1;

                if ( context_l->index.oids[1] > context_r->index.oids[1])
                        return 1;

                if ( context_l->index.oids[1] == context_r->index.oids[1]) {
                        /* If saHpiResourceEntryId index is equal sort by third index */
                        /* CHECK THIRD INDEX,  saHpiSensorNum */
                        if ( context_l->index.oids[2] < context_r->index.oids[2])
                                return -1;

                        if ( context_l->index.oids[2] > context_r->index.oids[2])
                                return 1;

                        if ( context_l->index.oids[2] == context_r->index.oids[2]) {
                                /* If saHpiSensorNum index is equal sort by forth index */
                                /* CHECK FORTH INDEX,  saHpiEventSeverity */
                                if ( context_l->index.oids[3] < context_r->index.oids[3])
                                        return -1;

                                if ( context_l->index.oids[3] > context_r->index.oids[3])
                                        return 1;

                                if ( context_l->index.oids[3] == context_r->index.oids[3]) {
				        /* If saHpiEventSeverity index is equal sort by forth index */
                                        /* CHECK FORTH INDEX,  saHpiSensorEnableChangeEventEntryId */
                                        if ( context_l->index.oids[4] < context_r->index.oids[4])
                                                return -1;

                                        if ( context_l->index.oids[4] > context_r->index.oids[4])
                                                return 1;

                                        if ( context_l->index.oids[4] == context_r->index.oids[4])
					        return 0;
				}	
                        }
                }
        }

        return 0;
}

/************************************************************
 * Initializes the saHpiSensorEnableChangeEventLogTable module
 */
void
init_saHpiSensorEnableChangeEventLogTable(void)
{
        
        DEBUGMSGTL ((AGENT, "init_saHpiSensorEnableChangeEventLogTable, called\n"));	
	
	initialize_table_saHpiSensorEnableChangeEventLogTable();

        initialize_table_saHpiSensorEnableChangeEventLogLifetimeChanges();
        initialize_table_saHpiSensorEnableChangeEventLogActiveEntries();
	
        domain_resource_pair_initialize(&initialized, &dr_table);
	
}

/************************************************************
 * the *_row_copy routine
 */
static int saHpiSensorEnableChangeEventLogTable_row_copy(saHpiSensorEnableChangeEventLogTable_context * dst,
                         saHpiSensorEnableChangeEventLogTable_context * src)
{
    if(!dst||!src)
        return 1;
        
    subagent_lock(&hpi_lock_data);
    /*
     * copy index, if provided
     */
    if(dst->index.oids)
        free(dst->index.oids);
    if(snmp_clone_mem( (void*)&dst->index.oids, src->index.oids,
                           src->index.len * sizeof(oid) )) {
        dst->index.oids = NULL;
        subagent_unlock(&hpi_lock_data);
        return 1;
    }
    dst->index.len = src->index.len;
    

    /*
     * copy components into the context structure
     */
    /** TODO: add code for external index(s)! */
    memcpy( dst->saHpiSensorEnableChangeEventLogTimestamp,
            src->saHpiSensorEnableChangeEventLogTimestamp,
	    src->saHpiSensorEnableChangeEventLogTimestamp_len);
	    
    dst->saHpiSensorEnableChangeEventLogTimestamp_len = src->saHpiSensorEnableChangeEventLogTimestamp_len;

    dst->saHpiSensorEnableChangeEventLogType = src->saHpiSensorEnableChangeEventLogType;

    dst->saHpiSensorEnableChangeEventLogCategory = src->saHpiSensorEnableChangeEventLogCategory;

    dst->saHpiSensorEnableChangeEventLogEnabled = src->saHpiSensorEnableChangeEventLogEnabled;

    dst->saHpiSensorEnableChangeEventLogEventsEnabled = src->saHpiSensorEnableChangeEventLogEventsEnabled;

    memcpy( dst->saHpiSensorEnableChangeEventLogAssertEvents, src->saHpiSensorEnableChangeEventLogAssertEvents, src->saHpiSensorEnableChangeEventLogAssertEvents_len );
    dst->saHpiSensorEnableChangeEventLogAssertEvents_len = src->saHpiSensorEnableChangeEventLogAssertEvents_len;

    memcpy( dst->saHpiSensorEnableChangeEventLogDeassertEvents, src->saHpiSensorEnableChangeEventLogDeassertEvents, src->saHpiSensorEnableChangeEventLogDeassertEvents_len );
    dst->saHpiSensorEnableChangeEventLogDeassertEvents_len = src->saHpiSensorEnableChangeEventLogDeassertEvents_len;

    memcpy( dst->saHpiSensorEnableChangeEventLogOptionalData, src->saHpiSensorEnableChangeEventLogOptionalData, src->saHpiSensorEnableChangeEventLogOptionalData_len );
    dst->saHpiSensorEnableChangeEventLogOptionalData_len = src->saHpiSensorEnableChangeEventLogOptionalData_len;

    memcpy( dst->saHpiSensorEnableChangeEventLogState, src->saHpiSensorEnableChangeEventLogState, src->saHpiSensorEnableChangeEventLogState_len );
    dst->saHpiSensorEnableChangeEventLogState_len = src->saHpiSensorEnableChangeEventLogState_len;

    subagent_unlock(&hpi_lock_data);
    return 0;
}

#ifdef saHpiSensorEnableChangeEventLogTable_SET_HANDLING

/**
 * the *_extract_index routine
 *
 * This routine is called when a set request is received for an index
 * that was not found in the table container. Here, we parse the oid
 * in the the individual index components and copy those indexes to the
 * context. Then we make sure the indexes for the new row are valid.
 */
int
saHpiSensorEnableChangeEventLogTable_extract_index( saHpiSensorEnableChangeEventLogTable_context * ctx, netsnmp_index * hdr )
{
        /*
         * temporary local storage for extracting oid index
         *
         * extract index uses varbinds (netsnmp_variable_list) to parse
         * the index OID into the individual components for each index part.
         */
        /** TODO: add storage for external index(s)! */
        netsnmp_variable_list var_saHpiDomainId;
        netsnmp_variable_list var_saHpiResourceId;
        netsnmp_variable_list var_saHpiSensorNum;
        netsnmp_variable_list var_saHpiEventSeverity;
        netsnmp_variable_list var_saHpiSensorEnableChangeEventEntryId;
        int err;

        DEBUGMSGTL ((AGENT, "saHpiAnnunciatorTable_extract_index, called\n"));
        subagent_lock(&hpi_lock_data);

        /*
         * copy index, if provided
         */
        if (hdr) {
                netsnmp_assert(ctx->index.oids == NULL);
                if (snmp_clone_mem( (void*)&ctx->index.oids, hdr->oids,
                                    hdr->len * sizeof(oid) )) {
                        return -1;
                        subagent_unlock(&hpi_lock_data);
                }
                ctx->index.len = hdr->len;
        }

        /*
         * initialize variable that will hold each component of the index.
         * If there are multiple indexes for the table, the variable_lists
         * need to be linked together, in order.
         */
        /** TODO: add code for external index(s)! */
        memset( &var_saHpiDomainId, 0x00, sizeof(var_saHpiDomainId) );
        var_saHpiDomainId.type = ASN_UNSIGNED; /* type hint for parse_oid_indexes */
        /** TODO: link this index to the next, or NULL for the last one */
        var_saHpiDomainId.next_variable = &var_saHpiResourceId;

        memset( &var_saHpiResourceId, 0x00, sizeof(var_saHpiResourceId) );
        var_saHpiResourceId.type = ASN_UNSIGNED; /* type hint for parse_oid_indexes */
        /** TODO: link this index to the next, or NULL for the last one */
        var_saHpiResourceId.next_variable = &var_saHpiSensorNum;

        memset( &var_saHpiSensorNum, 0x00, sizeof(var_saHpiSensorNum) );
        var_saHpiSensorNum.type = ASN_UNSIGNED; /* type hint for parse_oid_indexes */
        /** TODO: link this index to the next, or NULL for the last one */
        var_saHpiSensorNum.next_variable = &var_saHpiEventSeverity;

        memset( &var_saHpiEventSeverity, 0x00, sizeof(var_saHpiEventSeverity) );
        var_saHpiEventSeverity.type = ASN_INTEGER; /* type hint for parse_oid_indexes */
        /** TODO: link this index to the next, or NULL for the last one */
        var_saHpiEventSeverity.next_variable = &var_saHpiSensorEnableChangeEventEntryId;

        memset( &var_saHpiSensorEnableChangeEventEntryId, 0x00, sizeof(var_saHpiSensorEnableChangeEventEntryId) );
        var_saHpiSensorEnableChangeEventEntryId.type = ASN_UNSIGNED; /* type hint for parse_oid_indexes */
        /** TODO: link this index to the next, or NULL for the last one */
        var_saHpiSensorEnableChangeEventEntryId.next_variable = NULL;



        /*
         * parse the oid into the individual index components
         */
        err = parse_oid_indexes( hdr->oids, hdr->len, &var_saHpiDomainId );
        if (err == SNMP_ERR_NOERROR) {
                /*
                 * copy index components into the context structure
                 */
                /** skipping external index saHpiDomainId */
   
                /** skipping external index saHpiResourceId */
   
                /** skipping external index saHpiSensorNum */
   
                /** skipping external index saHpiEventSeverity */
   
                /** skipping external index saHpiSensorEnableChangeEventEntryId */
   
                err = saHpiDomainId_check_index(*var_saHpiDomainId.val.integer);
                err = saHpiResourceEntryId_check_index(*var_saHpiResourceId.val.integer);
		err = saHpiSensorNum_check_index(*var_saHpiSensorNum.val.integer);
		err = saHpiEventSeverity_check_index(*var_saHpiEventSeverity.val.integer);
		err = saHpiSensorEnableChangeEventEntryId_check_index(*var_saHpiSensorEnableChangeEventEntryId.val.integer);

        }

        /*
         * parsing may have allocated memory. free it.
         */
        snmp_reset_var_buffers( &var_saHpiDomainId );

        subagent_unlock(&hpi_lock_data);
        return err;
}

/************************************************************
 * the *_can_activate routine is called
 * when a row is changed to determine if all the values
 * set are consistent with the row's rules for a row status
 * of ACTIVE.
 *
 * return 1 if the row could be ACTIVE
 * return 0 if the row is not ready for the ACTIVE state
 */
int saHpiSensorEnableChangeEventLogTable_can_activate(saHpiSensorEnableChangeEventLogTable_context *undo_ctx,
                      saHpiSensorEnableChangeEventLogTable_context *row_ctx,
                      netsnmp_request_group * rg)
{
    /*
     * TODO: check for activation requirements here
     */


    /*
     * be optimistic.
     */
    return 1;
}

/************************************************************
 * the *_can_deactivate routine is called when a row that is
 * currently ACTIVE is set to a state other than ACTIVE. If
 * there are conditions in which a row should not be allowed
 * to transition out of the ACTIVE state (such as the row being
 * referred to by another row or table), check for them here.
 *
 * return 1 if the row can be set to a non-ACTIVE state
 * return 0 if the row must remain in the ACTIVE state
 */
int saHpiSensorEnableChangeEventLogTable_can_deactivate(saHpiSensorEnableChangeEventLogTable_context *undo_ctx,
                        saHpiSensorEnableChangeEventLogTable_context *row_ctx,
                        netsnmp_request_group * rg)
{
    /*
     * TODO: check for deactivation requirements here
     */
    return 1;
}

/************************************************************
 * the *_can_delete routine is called to determine if a row
 * can be deleted.
 *
 * return 1 if the row can be deleted
 * return 0 if the row cannot be deleted
 */
int saHpiSensorEnableChangeEventLogTable_can_delete(saHpiSensorEnableChangeEventLogTable_context *undo_ctx,
                    saHpiSensorEnableChangeEventLogTable_context *row_ctx,
                    netsnmp_request_group * rg)
{
    /*
     * probably shouldn't delete a row that we can't
     * deactivate.
     */
    if(saHpiSensorEnableChangeEventLogTable_can_deactivate(undo_ctx,row_ctx,rg) != 1)
        return 0;
    
    /*
     * TODO: check for other deletion requirements here
     */
    return 1;
}

#ifdef saHpiSensorEnableChangeEventLogTable_ROW_CREATION
/************************************************************
 * the *_create_row routine is called by the table handler
 * to create a new row for a given index. If you need more
 * information (such as column values) to make a decision
 * on creating rows, you must create an initial row here
 * (to hold the column values), and you can examine the
 * situation in more detail in the *_set_reserve1 or later
 * states of set processing. Simple check for a NULL undo_ctx
 * in those states and do detailed creation checking there.
 *
 * returns a newly allocated saHpiSensorEnableChangeEventLogTable_context
 *   structure if the specified indexes are not illegal
 * returns NULL for errors or illegal index values.
 */
saHpiSensorEnableChangeEventLogTable_context *
saHpiSensorEnableChangeEventLogTable_create_row( netsnmp_index* hdr)
{
    saHpiSensorEnableChangeEventLogTable_context * ctx =
        SNMP_MALLOC_TYPEDEF(saHpiSensorEnableChangeEventLogTable_context);
    if(!ctx)
        return NULL;

    subagent_lock(&hpi_lock_data);
        
    /*
     * TODO: check indexes, if necessary.
     */
    if(saHpiSensorEnableChangeEventLogTable_extract_index( ctx, hdr )) {
        free(ctx->index.oids);
        free(ctx);
        subagent_unlock(&hpi_lock_data);
        return NULL;
    }

    /* netsnmp_mutex_init(ctx->lock);
       netsnmp_mutex_lock(ctx->lock); */

    /*
     * TODO: initialize any default values here. This is also
     * first place you really should allocate any memory for
     * yourself to use.  If you allocated memory earlier,
     * make sure you free it for earlier error cases!
     */
    /**
    */

    sensor_enable_change_event_log_entry_count_total++;

    subagent_unlock(&hpi_lock_data);
    return ctx;
}
#endif

/************************************************************
 * the *_duplicate row routine
 */
saHpiSensorEnableChangeEventLogTable_context *
saHpiSensorEnableChangeEventLogTable_duplicate_row( saHpiSensorEnableChangeEventLogTable_context * row_ctx)
{
    saHpiSensorEnableChangeEventLogTable_context * dup;

    if(!row_ctx)
        return NULL;

    subagent_lock(&hpi_lock_data);
    dup = SNMP_MALLOC_TYPEDEF(saHpiSensorEnableChangeEventLogTable_context);
    if(!dup) {
            subagent_unlock(&hpi_lock_data);
            return NULL;
    }
        
    if(saHpiSensorEnableChangeEventLogTable_row_copy(dup,row_ctx)) {
        free(dup);
        dup = NULL;
    }

    subagent_unlock(&hpi_lock_data);
    return dup;
}

/************************************************************
 * the *_delete_row method is called to delete a row.
 */
netsnmp_index * saHpiSensorEnableChangeEventLogTable_delete_row( saHpiSensorEnableChangeEventLogTable_context * ctx )
{
  /* netsnmp_mutex_destroy(ctx->lock); */

        subagent_lock(&hpi_lock_data);

    if(ctx->index.oids)
        free(ctx->index.oids);

    /*
     * TODO: release any memory you allocated here...
     */

    /*
     * release header
     */
    free( ctx );

    sensor_enable_change_event_log_entry_count_total++;

    subagent_unlock(&hpi_lock_data);
    return NULL;
}


/************************************************************
 * RESERVE is used to check the syntax of all the variables
 * provided, that the values being set are sensible and consistent,
 * and to allocate any resources required for performing the SET.
 * After this stage, the expectation is that the set ought to
 * succeed, though this is not guaranteed. (In fact, with the UCD
 * agent, this is done in two passes - RESERVE1, and
 * RESERVE2, to allow for dependancies between variables).
 *
 * BEFORE calling this routine, the agent will call duplicate_row
 * to create a copy of the row (unless this is a new row; i.e.
 * row_created == 1).
 *
 * next state -> SET_RESERVE2 || SET_FREE
 */
void saHpiSensorEnableChangeEventLogTable_set_reserve1( netsnmp_request_group *rg )
{
//    saHpiSensorEnableChangeEventLogTable_context *row_ctx =
//            (saHpiSensorEnableChangeEventLogTable_context *)rg->existing_row;
//    saHpiSensorEnableChangeEventLogTable_context *undo_ctx =
//            (saHpiSensorEnableChangeEventLogTable_context *)rg->undo_info;
    netsnmp_variable_list *var;
    netsnmp_request_group_item *current;
    int rc;


    /*
     * TODO: loop through columns, check syntax and lengths. For
     * columns which have no dependencies, you could also move
     * the value/range checking here to attempt to catch error
     * cases as early as possible.
     */
    for( current = rg->list; current; current = current->next ) {

        var = current->ri->requestvb;
        rc = SNMP_ERR_NOERROR;

        switch(current->tri->colnum) {

        default: /** We shouldn't get here */
            rc = SNMP_ERR_GENERR;
            snmp_log(LOG_ERR, "unknown column in "
                     "saHpiSensorEnableChangeEventLogTable_set_reserve1\n");
        }

        if (rc)
           netsnmp_request_set_error( current->ri, rc );
        rg->status = SNMP_MAX( rg->status, current->ri->status );
    }

    /*
     * done with all the columns. Could check row related
     * requirements here.
     */
}

void saHpiSensorEnableChangeEventLogTable_set_reserve2( netsnmp_request_group *rg )
{
//    saHpiSensorEnableChangeEventLogTable_context *row_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->existing_row;
//    saHpiSensorEnableChangeEventLogTable_context *undo_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->undo_info;
    netsnmp_request_group_item *current;
    netsnmp_variable_list *var;
    int rc;

    rg->rg_void = rg->list->ri;

    /*
     * TODO: loop through columns, check for valid
     * values and any range constraints.
     */
    for( current = rg->list; current; current = current->next ) {

        var = current->ri->requestvb;
        rc = SNMP_ERR_NOERROR;

        switch(current->tri->colnum) {

        default: /** We shouldn't get here */
            netsnmp_assert(0); /** why wasn't this caught in reserve1? */
        }

        if (rc)
           netsnmp_request_set_error( current->ri, rc);
    }

    /*
     * done with all the columns. Could check row related
     * requirements here.
     */
}

/************************************************************
 * Assuming that the RESERVE phases were successful, the next
 * stage is indicated by the action value ACTION. This is used
 * to actually implement the set operation. However, this must
 * either be done into temporary (persistent) storage, or the
 * previous value stored similarly, in case any of the subsequent
 * ACTION calls fail.
 *
 * In your case, changes should be made to row_ctx. A copy of
 * the original row is in undo_ctx.
 */
void saHpiSensorEnableChangeEventLogTable_set_action( netsnmp_request_group *rg )
{
    netsnmp_variable_list *var;
//    saHpiSensorEnableChangeEventLogTable_context *row_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->existing_row;
//    saHpiSensorEnableChangeEventLogTable_context *undo_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->undo_info;
    netsnmp_request_group_item *current;

    int            row_err = 0;
    subagent_lock(&hpi_lock_data);

    /*
     * TODO: loop through columns, copy varbind values
     * to context structure for the row.
     */
    for( current = rg->list; current; current = current->next ) {

        var = current->ri->requestvb;

        switch(current->tri->colnum) {

        default: /** We shouldn't get here */
            netsnmp_assert(0); /** why wasn't this caught in reserve1? */
        }
    }

    /*
     * done with all the columns. Could check row related
     * requirements here.
     */
    if(row_err) {
        netsnmp_request_set_error((netsnmp_request_info*)rg->rg_void,
                                       row_err);
    }
    subagent_unlock(&hpi_lock_data);
    return;

}

/************************************************************
 * Only once the ACTION phase has completed successfully, can
 * the final COMMIT phase be run. This is used to complete any
 * writes that were done into temporary storage, and then release
 * any allocated resources. Note that all the code in this phase
 * should be "safe" code that cannot possibly fail (cue
 * hysterical laughter). The whole intent of the ACTION/COMMIT
 * division is that all of the fallible code should be done in
 * the ACTION phase, so that it can be backed out if necessary.
 *
 * BEFORE calling this routine, the agent will update the
 * container (inserting a row if row_created == 1, or removing
 * the row if row_deleted == 1).
 *
 * AFTER calling this routine, the agent will delete the
 * undo_info.
 */
void saHpiSensorEnableChangeEventLogTable_set_commit( netsnmp_request_group *rg )
{
    netsnmp_variable_list *var;
//    saHpiSensorEnableChangeEventLogTable_context *row_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->existing_row;
//    saHpiSensorEnableChangeEventLogTable_context *undo_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->undo_info;
    netsnmp_request_group_item *current;

    /*
     * loop through columns
     */
    for( current = rg->list; current; current = current->next ) {

        var = current->ri->requestvb;

        switch(current->tri->colnum) {

        default: /** We shouldn't get here */
            netsnmp_assert(0); /** why wasn't this caught in reserve1? */
        }
    }

    /*
     * done with all the columns. Could check row related
     * requirements here.
     */
}

/************************************************************
 * If either of the RESERVE calls fail, the write routines
 * are called again with the FREE action, to release any resources
 * that have been allocated. The agent will then return a failure
 * response to the requesting application.
 *
 * AFTER calling this routine, the agent will delete undo_info.
 */
void saHpiSensorEnableChangeEventLogTable_set_free( netsnmp_request_group *rg )
{
    netsnmp_variable_list *var;
//    saHpiSensorEnableChangeEventLogTable_context *row_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->existing_row;
 //   saHpiSensorEnableChangeEventLogTable_context *undo_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->undo_info;
    netsnmp_request_group_item *current;

    /*
     * loop through columns
     */
    for( current = rg->list; current; current = current->next ) {

        var = current->ri->requestvb;

        switch(current->tri->colnum) {

        default: /** We shouldn't get here */
	        break;
            /** should have been logged in reserve1 */
        }
    }

    /*
     * done with all the columns. Could check row related
     * requirements here.
     */
}

/************************************************************
 * If the ACTION phase does fail (for example due to an apparently
 * valid, but unacceptable value, or an unforeseen problem), then
 * the list of write routines are called again, with the UNDO
 * action. This requires the routine to reset the value that was
 * changed to its previous value (assuming it was actually changed),
 * and then to release any resources that had been allocated. As
 * with the FREE phase, the agent will then return an indication
 * of the error to the requesting application.
 *
 * BEFORE calling this routine, the agent will update the container
 * (remove any newly inserted row, re-insert any removed row).
 *
 * AFTER calling this routing, the agent will call row_copy
 * to restore the data in existing_row from the date in undo_info.
 * Then undo_info will be deleted (or existing row, if row_created
 * == 1).
 */
void saHpiSensorEnableChangeEventLogTable_set_undo( netsnmp_request_group *rg )
{
    netsnmp_variable_list *var;
//    saHpiSensorEnableChangeEventLogTable_context *row_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->existing_row;
//    saHpiSensorEnableChangeEventLogTable_context *undo_ctx = (saHpiSensorEnableChangeEventLogTable_context *)rg->undo_info;
    netsnmp_request_group_item *current;

    /*
     * loop through columns
     */
    for( current = rg->list; current; current = current->next ) {

        var = current->ri->requestvb;

        switch(current->tri->colnum) {

        default: /** We shouldn't get here */
            netsnmp_assert(0); /** why wasn't this caught in reserve1? */
        }
    }

    /*
     * done with all the columns. Could check row related
     * requirements here.
     */
}

#endif /** saHpiSensorEnableChangeEventLogTable_SET_HANDLING */


/************************************************************
 *
 * Initialize the saHpiSensorEnableChangeEventLogTable table by defining its contents and how it's structured
 */
void
initialize_table_saHpiSensorEnableChangeEventLogTable(void)
{
    netsnmp_table_registration_info *table_info;

    if(my_handler) {
        snmp_log(LOG_ERR, "initialize_table_saHpiSensorEnableChangeEventLogTable_handler called again\n");
        return;
    }

    memset(&cb, 0x00, sizeof(cb));

    /** create the table structure itself */
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);

    /* if your table is read only, it's easiest to change the
       HANDLER_CAN_RWRITE definition below to HANDLER_CAN_RONLY */
    my_handler = netsnmp_create_handler_registration("saHpiSensorEnableChangeEventLogTable",
                                             netsnmp_table_array_helper_handler,
                                             saHpiSensorEnableChangeEventLogTable_oid,
                                             saHpiSensorEnableChangeEventLogTable_oid_len,
                                             HANDLER_CAN_RWRITE);
            
    if (!my_handler || !table_info) {
        snmp_log(LOG_ERR, "malloc failed in "
                 "initialize_table_saHpiSensorEnableChangeEventLogTable_handler\n");
        return; /** mallocs failed */
    }

    /***************************************************
     * Setting up the table's definition
     */
    /*
     * TODO: add any external indexes here.
     */
        /** TODO: add code for external index(s)! */

    /*
     * internal indexes
     */
        /** index: saHpiDomainId */
        netsnmp_table_helper_add_index(table_info, ASN_UNSIGNED);
        /** index: saHpiResourceId */
        netsnmp_table_helper_add_index(table_info, ASN_UNSIGNED);
        /** index: saHpiSensorNum */
        netsnmp_table_helper_add_index(table_info, ASN_UNSIGNED);
        /** index: saHpiEventSeverity */
        netsnmp_table_helper_add_index(table_info, ASN_INTEGER);
        /** index: saHpiSensorEnableChangeEventEntryId */
        netsnmp_table_helper_add_index(table_info, ASN_UNSIGNED);

    table_info->min_column = saHpiSensorEnableChangeEventLogTable_COL_MIN;
    table_info->max_column = saHpiSensorEnableChangeEventLogTable_COL_MAX;

    /***************************************************
     * registering the table with the master agent
     */
    cb.get_value = saHpiSensorEnableChangeEventLogTable_get_value;
    cb.container = netsnmp_container_find("saHpiSensorEnableChangeEventLogTable_primary:"
                                          "saHpiSensorEnableChangeEventLogTable:"
                                          "table_container");
#ifdef saHpiSensorEnableChangeEventLogTable_IDX2
    netsnmp_container_add_index(cb.container,
                                netsnmp_container_find("saHpiSensorEnableChangeEventLogTable_secondary:"
                                                       "saHpiSensorEnableChangeEventLogTable:"
                                                       "table_container"));
    cb.container->next->compare = saHpiSensorEnableChangeEventLogTable_cmp;
#endif
#ifdef saHpiSensorEnableChangeEventLogTable_SET_HANDLING
    cb.can_set = 1;
#ifdef saHpiSensorEnableChangeEventLogTable_ROW_CREATION
    cb.create_row = (UserRowMethod*)saHpiSensorEnableChangeEventLogTable_create_row;
#endif
    cb.duplicate_row = (UserRowMethod*)saHpiSensorEnableChangeEventLogTable_duplicate_row;
    cb.delete_row = (UserRowMethod*)saHpiSensorEnableChangeEventLogTable_delete_row;
    cb.row_copy = (Netsnmp_User_Row_Operation *)saHpiSensorEnableChangeEventLogTable_row_copy;

    cb.can_activate = (Netsnmp_User_Row_Action *)saHpiSensorEnableChangeEventLogTable_can_activate;
    cb.can_deactivate = (Netsnmp_User_Row_Action *)saHpiSensorEnableChangeEventLogTable_can_deactivate;
    cb.can_delete = (Netsnmp_User_Row_Action *)saHpiSensorEnableChangeEventLogTable_can_delete;

    cb.set_reserve1 = saHpiSensorEnableChangeEventLogTable_set_reserve1;
    cb.set_reserve2 = saHpiSensorEnableChangeEventLogTable_set_reserve2;
    cb.set_action = saHpiSensorEnableChangeEventLogTable_set_action;
    cb.set_commit = saHpiSensorEnableChangeEventLogTable_set_commit;
    cb.set_free = saHpiSensorEnableChangeEventLogTable_set_free;
    cb.set_undo = saHpiSensorEnableChangeEventLogTable_set_undo;
#endif
    DEBUGMSGTL(("initialize_table_saHpiSensorEnableChangeEventLogTable",
                "Registering table saHpiSensorEnableChangeEventLogTable "
                "as a table array\n"));
    netsnmp_table_container_register(my_handler, table_info, &cb,
                                     cb.container, 1);
}

/************************************************************
 * saHpiSensorEnableChangeEventLogTable_get_value
 *
 * This routine is called for get requests to copy the data
 * from the context to the varbind for the request. If the
 * context has been properly maintained, you don't need to
 * change in code in this fuction.
 */
int saHpiSensorEnableChangeEventLogTable_get_value(
            netsnmp_request_info *request,
            netsnmp_index *item,
            netsnmp_table_request_info *table_info )
{
    netsnmp_variable_list *var = request->requestvb;
    saHpiSensorEnableChangeEventLogTable_context *context = (saHpiSensorEnableChangeEventLogTable_context *)item;

    switch(table_info->colnum) {

        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGTIMESTAMP:
            /** SaHpiTime = ASN_OCTET_STR */
            snmp_set_var_typed_value(var, ASN_OCTET_STR,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogTimestamp,
                         sizeof(context->saHpiSensorEnableChangeEventLogTimestamp) );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGTYPE:
            /** SaHpiSensorType = ASN_INTEGER */
            snmp_set_var_typed_value(var, ASN_INTEGER,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogType,
                         sizeof(context->saHpiSensorEnableChangeEventLogType) );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGCATEGORY:
            /** SaHpiEventCategory = ASN_INTEGER */
            snmp_set_var_typed_value(var, ASN_INTEGER,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogCategory,
                         sizeof(context->saHpiSensorEnableChangeEventLogCategory) );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGENABLED:
            /** TruthValue = ASN_INTEGER */
            snmp_set_var_typed_value(var, ASN_INTEGER,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogEnabled,
                         sizeof(context->saHpiSensorEnableChangeEventLogEnabled) );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGEVENTSENABLED:
            /** TruthValue = ASN_INTEGER */
            snmp_set_var_typed_value(var, ASN_INTEGER,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogEventsEnabled,
                         sizeof(context->saHpiSensorEnableChangeEventLogEventsEnabled) );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGASSERTEVENTS:
            /** SaHpiEventState = ASN_OCTET_STR */
            snmp_set_var_typed_value(var, ASN_OCTET_STR,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogAssertEvents,
                         context->saHpiSensorEnableChangeEventLogAssertEvents_len );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGDEASSERTEVENTS:
            /** SaHpiEventState = ASN_OCTET_STR */
            snmp_set_var_typed_value(var, ASN_OCTET_STR,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogDeassertEvents,
                         context->saHpiSensorEnableChangeEventLogDeassertEvents_len );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGOPTIONALDATA:
            /** SaHpiOptionalData = ASN_OCTET_STR */
            snmp_set_var_typed_value(var, ASN_OCTET_STR,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogOptionalData,
                         context->saHpiSensorEnableChangeEventLogOptionalData_len );
        break;
    
        case COLUMN_SAHPISENSORENABLECHANGEEVENTLOGSTATE:
            /** SaHpiEventState = ASN_OCTET_STR */
            snmp_set_var_typed_value(var, ASN_OCTET_STR,
                         (u_char*)&context->saHpiSensorEnableChangeEventLogState,
                         context->saHpiSensorEnableChangeEventLogState_len );
        break;
    
    default: /** We shouldn't get here */
        snmp_log(LOG_ERR, "unknown column in "
                 "saHpiSensorEnableChangeEventLogTable_get_value\n");
        return SNMP_ERR_GENERR;
    }
    return SNMP_ERR_NOERROR;
}

/************************************************************
 * saHpiSensorEnableChangeEventLogTable_get_by_idx
 */
const saHpiSensorEnableChangeEventLogTable_context *
saHpiSensorEnableChangeEventLogTable_get_by_idx(netsnmp_index * hdr)
{
    return (const saHpiSensorEnableChangeEventLogTable_context *)
        CONTAINER_FIND(cb.container, hdr );
}


